/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.BattleField
 *  fire.pb.battle.DemoResult
 *  fire.pb.battle.Fighter
 *  fire.pb.instancezone.InstanceZone
 *  fire.pb.instancezone.InstanceZoneFactory
 *  fire.pb.instancezone.faction.FactionInstZone
 *  fire.pb.util.Misc
 *  xbean.BattleInfo
 *  xbean.ClanBossInfo
 *  xbean.ClanInstances
 *  xbean.Fighter
 *  xtable.Properties
 */
package fire.pb.option;

import fire.pb.battle.BattleField;
import fire.pb.battle.DemoResult;
import fire.pb.instancezone.InstanceZone;
import fire.pb.instancezone.InstanceZoneFactory;
import fire.pb.instancezone.faction.FactionInstZone;
import fire.pb.option.BasicOperation;
import fire.pb.util.Misc;
import java.util.LinkedList;
import xbean.BattleInfo;
import xbean.ClanBossInfo;
import xbean.ClanInstances;
import xbean.Fighter;
import xtable.Properties;

public class Runaway
extends BasicOperation {
    public static final int DEFAULT_ESCAPE_ODDS = 60;
    private int escapeOdds = 60;
    private boolean success = false;

    public Runaway(BattleInfo battle, int operator) {
        super(battle, operator, operator);
    }

    public Runaway(BattleInfo battle, int operator, int escapeOdds) {
        super(battle, operator, operator);
        if (escapeOdds >= 0) {
            this.escapeOdds = escapeOdds;
        }
    }

    @Override
    public int getOperateID() {
        return 0;
    }

    @Override
    public LinkedList<DemoResult> getDemoResult() {
        LinkedList<DemoResult> list = new LinkedList<DemoResult>();
        DemoResult r = new DemoResult();
        r.targetid = this.getAim();
        fire.pb.battle.Fighter opFighter = (fire.pb.battle.Fighter)this.getBattle().getFighterobjects().get(this.getOperator());
        r.targetresult = opFighter.getBuffAgent().existBuff(502028) && this.escapeOdds == 100 ? 1024 : this.getResultType();
        this.processActiveHidden();
        list.add(r);
        if (this.success) {
            InstanceZone instzone;
            fire.pb.battle.Fighter fighter = (fire.pb.battle.Fighter)this.getBattle().getFighterobjects().get(this.getOperator());
            if (this.getBattle().getBattletype() == 50 && fighter.getBuffAgent().existBuff(509200) && (instzone = InstanceZoneFactory.getRoleCurInstanceZone((long)this.getBattle().getHostroleid(), (boolean)false)) != null && instzone instanceof FactionInstZone) {
                ClanInstances clanInst = ((FactionInstZone)instzone).getClanInstData();
                if (((FactionInstZone)instzone).checkBattleid(this.getBattle().getConfigid())) {
                    ClanBossInfo bossinfo = (ClanBossInfo)clanInst.getBossinfo().get(this.getBattle().getConfigid());
                    fire.pb.battle.Fighter boss = (fire.pb.battle.Fighter)this.getBattle().getFighterobjects().get(bossinfo.getFighteindx());
                    DemoResult demoresult = new DemoResult();
                    demoresult.targetid = bossinfo.getFighteindx();
                    demoresult.targetresult = 1;
                    boss.getEffectRole().setHp(boss.getEffectRole().getHp() - fighter.getFighterBean().getInihp());
                    demoresult.hpchange = -fighter.getFighterBean().getInihp();
                    list.add(demoresult);
                }
            }
        }
        return list;
    }

    @Override
    public int getResultType() {
        return this.success ? 1024 : 0;
    }

    @Override
    public int getType() {
        return 9;
    }

    @Override
    public void process() {
        Fighter f = (Fighter)this.getBattle().getFighters().get(this.getOperator());
        if (null == f) {
            return;
        }
        if (!this.success) {
            return;
        }
        if (f.getFightertype() == 1) {
            Integer result = (Integer)this.getBattle().getRoundresult().get(f.getBattleindex());
            result = result == null ? 0 : result;
            this.getBattle().getRoundresult().put(f.getBattleindex(), result | 0x400);
            int petIndex = f.getBattleindex() + 5;
            if (!BattleField.checkOutBattle((BattleInfo)this.getBattle(), (int)petIndex)) {
                Integer result2 = (Integer)this.getBattle().getRoundresult().get(petIndex);
                result2 = result2 == null ? 0 : result2;
                this.getBattle().getRoundresult().put(petIndex, result2 | 0x400);
                int petkey = Properties.selectFightpetkey((Long)f.getUniqueid());
                f.getFightedpets().put(petkey, 1024);
            }
        } else if (f.getFightertype() == 2) {
            int roleIndex = f.getBattleindex() - 5;
            if (!this.getBattle().getFighters().containsKey(roleIndex)) {
                return;
            }
            Fighter owner = (Fighter)this.getBattle().getFighters().get(roleIndex);
            long roleid = owner.getUniqueid();
            Integer result = (Integer)this.getBattle().getRoundresult().get(f.getBattleindex());
            result = result == null ? 0 : result;
            this.getBattle().getRoundresult().put(f.getBattleindex(), result | 0x400);
            int petkey = Properties.selectFightpetkey((Long)roleid);
            owner.getFightedpets().put(petkey, 1024);
        } else if (f.getFightertype() >= 3) {
            Integer result = (Integer)this.getBattle().getRoundresult().get(f.getBattleindex());
            result = result == null ? 0 : result;
            this.getBattle().getRoundresult().put(f.getBattleindex(), result | 0x400);
        }
    }

    @Override
    public boolean checkEffective() {
        if (!this.checkOperator()) {
            return false;
        }
        if (this.opfighter.getBuffAgent().existBuff(507033)) {
            return true;
        }
        if (this.opfighter.getSkillAgent().hasEffectSkill(430032)) {
            this.escapeOdds = 70;
        }
        if (this.escapeOdds >= 100) {
            this.success = true;
            return true;
        }
        if (!(this.getBattle().getCanrunaway() || this.opfighter.getFightertype() != 1 && this.opfighter.getFightertype() != 2)) {
            return true;
        }
        if (BattleField.logger.isDebugEnabled()) {
            BattleField.logger.debug((Object)(this.opfighter.getFighterId() + "选择逃跑， TA有百分之" + this.escapeOdds + "的几率能跑掉"));
        }
        if (Misc.checkRatePercent((int)this.escapeOdds)) {
            this.success = true;
            return true;
        }
        return true;
    }

    public String toString() {
        return this.getOperator() + "\t选择逃跑";
    }

    @Override
    public boolean canChangeAim() {
        return false;
    }
}

